// ======================================================================
//
// MonoDebug.h
// jeff grills
//
// copyright 1995 origin systems inc
//
// ======================================================================

#ifndef MONO_DEBUG_H
#define MONO_DEBUG_H

#ifndef NMONO

// ======================================================================

class MonoDebug
{
private:

	static HANDLE  VxD;

private:

	static void fatalRemove(void);

public:
	// this is only public for the macros!  do not touch!
	static int     installed;

public:

	static void install(void);
	static void remove(void);

	static void clear(void);
	static void clearToCursor(void);
	static void setCursor(int x, int y);
	static void copyTo(const char *scrn);
	static void copyFrom(char *scrn);
	static void print(const char *str);
};

// ======================================================================

inline void MonoInstall(void)
{
	MonoDebug::install();
}

inline void MonoRemove(void)
{
	MonoDebug::remove();
}

inline void MonoClear(void)
{
	if (MonoDebug::installed)
		MonoDebug::clear();
}

inline void MonoClearToCursor(void)
{
	if (MonoDebug::installed)
		MonoDebug::clearToCursor();
}

inline void MonoSetCursor(int x, int y)
{
	if (MonoDebug::installed)
		MonoDebug::setCursor(x, y);
}

inline void MonoCopyTo(const char *buffer)
{
	if (MonoDebug::installed)
		MonoDebug::copyTo(buffer);
}

inline void MonoCopyFrom(char *buffer)
{
	if (MonoDebug::installed)
		MonoDebug::copyFrom(buffer);
}

inline void MonoPrint(const char *str)
{
	if (MonoDebug::installed)
		MonoDebug::print(str);
}

// ======================================================================
#else

inline void MonoInstall(void)
{
}

inline void MonoRemove(void)
{
}

inline void MonoClear(void)
{
}

inline void MonoClearToCursor(void)
{
}

inline void MonoSetCursor(int, int)
{
}

inline void MonoCopyTo(char *)
{
}

inline void MonoCopyFrom(const char *)
{
}

inline void MonoPrint(const char *)
{
}

// ======================================================================

#endif
#endif
